/*
  

   Winavr 
*/

#define F_OSC 1200000 //  
#include <avr/io.h>
#include <avr/delay.h>
#include <avr/interrupt.h>
volatile char  levels[4], // : 0- . 1 - .
			   half_waves,//   
			   skip,      //   
			   counter1,  //   (0...15 -  , 
						  //16...31 -  ,  DD2  "" * )
			   counter2,  //    DD3  "" *
			   shift,	  //      DD4  "" *
			   period;	  //      
						  //(    )

//* -       
// "  "  11/1984 . 52-53

//   EEPROM - ,     
void EEPROM_write(unsigned char ucAddress, unsigned char ucData)
{
	while(EECR & (1<<EEWE));		//    
	EECR = (0<<EEPM1)|(0>>EEPM0); 	//  
	EEARL = ucAddress;				// 
	EEDR = ucData;    				// 
	EECR |= (1<<EEMWE); 			//   = 1
	EECR |= (1<<EEWE); 			// 
}

//   EEPROM - ,     
unsigned char EEPROM_read(unsigned char ucAddress)
{
	while(EECR & (1<<EEWE));		//    
	EEARL = ucAddress;				// 
	EECR |= (1<<EERE);				//  
	return EEDR; 					//  
}

//    ()  
//(     )
void step()
{
	if(++half_waves==period) 	//    ?
	{							//  - 
		half_waves=0;			//  
		if(++counter1==32) 	//   ""
		{
			counter1=0;			//  
			counter2++;			//   1  
		};
		if(counter1<=15)		//    
			shift=counter2; 	//    (  ) - 
								// . 2-   . 
			else 
			{
				shift=(shift*2)+(shift&8)/8; //      
			};
	}
	levels[0]=0;				//   shift    
	levels[1]=0;				//(     )
	levels[2]=0;
	levels[3]=0;
	if((shift&1)!=0)levels[0]=1;
	if((shift&2)!=0)levels[1]=1;
	if((shift&4)!=0)levels[2]=1;
	if((shift&8)!=0)levels[3]=1;
}

//     
void init()
{
	half_waves=0;
	counter1=16;
	counter2=1;
	shift=1;
}

//          0
ISR(PCINT0_vect)
{
	skip=0;						//   
	PORTB=1+2+4+16;				//    ( )
	if(levels[0]!=0)PORTB-=1;	// . "0"   ,   
	if(levels[1]!=0)PORTB-=2;
	if(levels[2]!=0)PORTB-=4;
	if(levels[3]!=0)PORTB-=16;
	_delay_us(500);				//   
	PORTB=1+2+4+16;				//     
	step();					//   
}

void main(void)
{
	unsigned long int delay_cnt;//   
	DDRB=1+2+4+16;				//   -  
	PORTB=1+2+4+16;				//   
	GIMSK=32;					// 
	PCMSK=8;
	init();				// 
	period=EEPROM_read(0);		//   
	if((period<25)||(period>250)) //     
	{
		period=150;					//   
		EEPROM_write(0,period);
	}
	_delay_ms(3000);			//    (     ..)
	sei();						// 
	skip=0;						//   
	for(;;)						//  -      
	{
		for(delay_cnt=0;delay_cnt<=5000;delay_cnt++);	//  20  (   ,  
														//    ,     )
		skip++;											//   
		if(skip>=4)										//     80  - ,    
		{
			cli();					// 				
			skip=0;					//   
			if(period<=225)			//     
				period+=25;			//  
				else 
				period=25;			//    
			init();			//    
			//  ,          
			// ,            
			for(delay_cnt=0;delay_cnt<=15;delay_cnt++) // 15 
			{
				while((PINB&8)==0); //,   "" 
				while((PINB&8)==8); //,   "" 
			}
			EEPROM_write(0,period); //     EEPROM
			sei();					//  -   
		};
	};
}